/*******************************************************************************
*
*
* File:        app_tp_for_custom.h
* Description  tp Э鴦ļضõĺ
* Version      V0.1
* Date         2021-10-14
* Author       zhanghz
*******************************************************************************/
#ifndef __APP_TP_FOR_CUSTOM_S8_H__
#define __APP_TP_FOR_CUSTOM_S8_H__
#include "test_cfg_global.h"

#include "string.h"
#include "tau_device_datatype.h"
#include "tau_common.h"
#include "app_tp_transfer.h"
#include "hal_gpio.h"

#define AP_TP_TRANSFER            1

#if AMOLED_NT37280
    #define PHONE_SLAVE_TRANSFER_I2C       1                //1:ʾֻоƬ֮䣬touch ݲ I2C ͨţ
    #define PHONE_SLAVE_TRANSFER_SPI       0                //1:ʾֻоƬ֮䣬touch ݲ SPI ͨţ
    #define SCREEN_MASTER_TRANSFER_I2C     0                //1:ʾĻоƬ֮䣬touch ݲ I2C ͨţ
    #define SCREEN_MASTER_TRANSFER_SPI     1                //1:ʾĻоƬ֮䣬touch ݲ SPI ͨţ
#elif LCD_HX83112A
    #define PHONE_SLAVE_TRANSFER_I2C       1                //1:ʾֻоƬ֮䣬touch ݲ I2C ͨţ
    #define PHONE_SLAVE_TRANSFER_SPI       0                //1:ʾֻоƬ֮䣬touch ݲ SPI ͨţ
    #define SCREEN_MASTER_TRANSFER_I2C     0                //1:ʾĻоƬ֮䣬touch ݲ I2C ͨţ
    #define SCREEN_MASTER_TRANSFER_SPI     0                //1:ʾĻоƬ֮䣬touch ݲ SPI ͨţ
#else // #if LCD_TD4310
    #define PHONE_SLAVE_TRANSFER_I2C       1                //1:ʾֻоƬ֮䣬touch ݲ I2C ͨţ
    #define PHONE_SLAVE_TRANSFER_SPI       0                //1:ʾֻоƬ֮䣬touch ݲ SPI ͨţ
    #define SCREEN_MASTER_TRANSFER_I2C     1                //1:ʾĻоƬ֮䣬touch ݲ I2C ͨţ
    #define SCREEN_MASTER_TRANSFER_SPI     0                //1:ʾĻоƬ֮䣬touch ݲ SPI ͨţ
#endif

#ifdef USE_FOR_SAMSUNG_Note10Lite
#define CHIP_I2C_ADDRESS               0x48             //оƬ I2C ӻַ.I2Cַ
#define SCREEN_I2C_ADDRESS             0x49             //Ļ I2C ӻַ

#elif defined(USE_FOR_SUMSUNG_S9PLUS)
#define CHIP_I2C_ADDRESS               0x48             //оƬ I2C ӻַ
#define SCREEN_I2C_ADDRESS             0x20             //Ļ I2C ӻַ

#else
#define CHIP_I2C_ADDRESS               0x48             //оƬ I2C ӻַ
#define SCREEN_I2C_ADDRESS             0x49             //Ļ I2C ӻַ
#endif

#define CHIP_I2C_ADDR_BITS             I2C_ADDR_BITS_7  //Ļ I2C ַλ 7/10ĬΪ7
#define SCREEN_I2C_ADDR_BITS           I2C_ADDR_BITS_7  //Ļ I2C ַλ 7/10ĬΪ7
#define I2C_MASTER_SPEED               800000           // I2C ͨ

#define SPI_MASTER_SPEED               10000000    // SPI ͨ

#define BUFFER_SIZE_MAX                200         // bufrer ֽ

#define INPUT_WIDTH_VALUE              1440        //ԭװ X ֵֵ
#define INPUT_HEIGHT_VALUE             3200        //ԭװ Y ֵֵ

#define OUTPUT_WIDTH_VALUE             1080        //ά X ֵֵ
#define OUTPUT_HEIGHT_VALUE            2400        //ά Y ֵֵ


#define SCREEN_TRANSFER_WRITE          false       //յscreen ioжϣ֮ö
#define SCREEN_TRANSFER_READ           true        //յscreen ioжϣ֮Ҫ

typedef enum
{
    I2C_ADDR_BITS_7  = 7,
    I2C_ADDR_BITS_10 = 10
} en_I2C_ADDR_BITS_mdoe;

typedef struct
{
    uint8_t *buffer;                               //յscreen ioжϺͨŵķbufferָ
    size_t txbuffer_size;                          // buffer ݳȣҪʱĿǰֻ֧4ֽ
    size_t rxbuffer_size;                          //֮Ҫصݳ
    bool read_flag;                                //true յscreen ioжϣ֮Ҫ
} st_screen_data;

typedef struct
{
    const uint8_t *buffer;                         //ͨŵķbufferָ
    size_t txbuffer_size;                          // buffer ݳȣҪʱĿǰֻ֧4ֽ
    size_t rxbuffer_size;                          //֮Ҫصݳ
    bool read_flag;                                //true յscreen ioжϣ֮Ҫ
} st_screen_const_data;

typedef struct
{
    uint8_t reg_size;                              //bufferĸ
    size_t write_back_size;                        //Ҫ͵ݳ
    const uint8_t *reg_data;                       //buffer
    const uint8_t *write_back;                     //bufer
} st_reg_const_data;

typedef struct
{
    uint8_t reg_size;                              //bufferĸ
    size_t write_back_size;                        //Ҫ͵ݳ
    uint8_t *reg_data;                             //buffer
    uint8_t *write_back;                           //bufer
} st_reg_data;

extern io_pad_e g_screen_input_rst_pad;
extern io_pad_e g_screen_input_int_pad;
extern io_pad_e g_phone_input_rst_pad;
extern io_pad_e g_phone_output_int_pad;

extern uint8_t phone_start_flag;
extern uint8_t phone_touch_flag;

extern uint8_t send_point;
extern uint8_t fingerprint_enable;
extern uint8_t phone_reg_coord_back[200];
extern const uint8_t screen_reg_int_data_size;
extern const uint8_t screen_reg_start_data_size;
extern st_screen_data screen_reg_int_data[];
extern st_screen_const_data screen_reg_start_data[];
//extern st_reg_const_data phone_reg_const_data[];

/**************************************************************************
* @name : app_tp_screen_analysis_const
* @brief : screen start ׶ݽɿͻ
* @param[in] :
* @return :
* @retval :
**************************************************************************/
uint8_t app_tp_screen_analysis_const(uint8_t transfer_now, uint8_t *rxbuffer, size_t data_size);

/**************************************************************************
* @name : app_tp_screen_analysis_int
* @brief : screen IOжϺ ݽɿͻ
* @param[in] :
* @return :
* @retval :
**************************************************************************/
uint8_t app_tp_screen_analysis_int(uint8_t transfer_now, uint8_t *rxbuffer, size_t data_size);

/**************************************************************************
* @name : app_tp_phone_analysis_data
* @brief : phone ݽɿͻ
* @param[in] :
* @return :
* @retval :
**************************************************************************/
void app_tp_phone_analysis_data(uint8_t *rxbuffer, size_t rxbuffer_size, const uint8_t **txbuffer, size_t *txbuffer_size);


#endif

