/*******************************************************************************
*
*
* File:        app_tp_st_touch.h
* Description  ST touch оƬغ
* Version      V0.1
* Date         2023-03-13
* Author       sfy
*******************************************************************************/

#ifndef __APP_TP_ST_TOUCH_H__
#define __APP_TP_ST_TOUCH_H__

#include "string.h"
#include "tau_device_datatype.h"
#include "tau_common.h"
#include "hal_dsi_rx_ctrl.h"

typedef enum
{
    CMD_TP_CABLIBRATION  = 0x2A,
    CMD_SET_IMAGE_RGB    = 0x2B,
    CMD_SEND_COMMAND     = 0x2C,
    CMD_WRITE_GAMMA      = 0x2D,
    CMD_START_GAMMA      = 0x2E
} st_tp_calibration_command;

	
#define  ST_TP_SCAN_POINT_NUMBER_MAX				6		 // TP 

typedef struct
{
    uint8_t tp_point_buffer[ST_TP_SCAN_POINT_NUMBER_MAX];    // ¼TPID
    uint8_t tp_read_point_counter;                    		 // IDͳ
    uint8_t tp_point_up_error_flag;                   		 // ¼ҪִUP¼
    uint32_t tp_point_error_time_counter;                 	 // ûյmove¼release¼ʱ
} st_tp_scan_data;

/**************************************************************************
* @name : ap_tp_st_touch_calibration
* @brief : st touch У׼ָ
* @param[in] :
* @return :
* @retval :
**************************************************************************/

void ap_tp_st_touch_calibration(void);

/**************************************************************************
* @name : app_tp_calibration_exec
* @brief : st touch У׼ִк
* @param[in] :
* @return :
* @retval :
**************************************************************************/

void app_tp_calibration_exec(void);

/**************************************************************************
* @name : ap_tp_st_touch_get_calibration_success_mark
* @brief : st touch ȡУ׼ɹ־
* @param[in] :
* @return :
* @retval :
**************************************************************************/

void ap_tp_st_touch_get_calibration_success_mark(void);

/**************************************************************************
* @name : ap_set_tp_calibration_04
* @brief : ȡ04 02ִУ׼gammaУ׼ȹ
* @param[in] :handler rx handler; dcs_packet ָͳȵϢṹ
* @return : true
* @retval :
**************************************************************************/

bool ap_set_tp_calibration_04(hal_dsi_rx_ctrl_handle_t *handler, hal_dcs_packet_t *dcs_packet);

/**************************************************************************
* @name : ap_get_tp_calibration_status_01
* @brief : ȡУ׼״̬
* @param[in] :param 01
* @return : true
* @retval :
**************************************************************************/

bool ap_get_tp_calibration_status_01(hal_dsi_rx_ctrl_handle_t *handler, uint8_t param);

/**************************************************************************
* @name : ap_tp_st_touch_scan_point_init
* @brief : st touch tp_scan_dataṹʼ
* @param[in] :
* @return :
* @retval :
**************************************************************************/

void ap_tp_st_touch_scan_point_init(void);

/**************************************************************************
* @name : ap_tp_st_touch_simulate_finger_release_event
* @brief : st touch ģST ָͷ¼
* @param[in] :
* @return :
* @retval :
**************************************************************************/

void ap_tp_st_touch_simulate_finger_release_event(void);

/**************************************************************************
* @name : ap_tp_st_touch_software_reset
* @brief : st touch оƬλָ
* @param[in] :
* @return :
* @retval :
**************************************************************************/

void ap_tp_st_touch_software_reset(void);

/**************************************************************************
* @name : app_tp_st_touch_hardware_reset
* @brief : st touch оƬӲλָ
* @param[in] :
* @return :
* @retval :
**************************************************************************/
void ap_tp_st_touch_hardware_reset(void);

/**************************************************************************
* @name : ap_tp_st_touch_scan_point_record_event
* @brief : st touch ¼¼
* @param[in] : screendata buflen ݳ
* @return :
* @retval :
**************************************************************************/

void ap_tp_st_touch_scan_point_record_event(uint8_t* screendata,uint8_t len);

/**************************************************************************
* @name : ap_tp_st_touch_scan_point_record_event_exec
* @brief : st touch в㣬ʱִкҪwhile(1)ִ
* @param[in] : 
* @return :
* @retval :
**************************************************************************/

void ap_tp_st_touch_scan_point_record_event_exec(void);

/**************************************************************************
* @name : ap_tp_st_touch_error_handler_F3
* @brief : st touch 쳣 F3 02 
* @param[in] : screendata 
* @return :
* @retval :
**************************************************************************/

void ap_tp_st_touch_error_handler_F3(uint8_t* screendata);

/**************************************************************************
* @name : ap_tp_st_touch_error_handler_F3
* @brief : st touch 쳣 FF FF 
* @param[in] : screendata 
* @return :
* @retval :
**************************************************************************/

void ap_tp_st_touch_error_handler_FF(uint8_t* screendata);


#endif

