/*******************************************************************************
*
*
* File:        app_tp_transfer.c
* Description  touch I2C/SPI ʼԼͨ
* Version      V0.1
* Date         2021-10-14
* Author       zhanghz
*******************************************************************************/
#include "test_cfg_global.h"
#include "app_tp_transfer.h"
#include "hal_i2c_master.h"
#include "hal_i2c_slave.h"
#include "hal_spi_master.h"
#include "hal_spi_slave.h"
#include "tau_log.h"
#include "tau_delay.h"
#include "app_tp_for_custom_s8.h"


#if 1//def AP_TP_TRANSFER
uint8_t read_point;							//ǰҪıһ8BYTE
uint8_t s_screen_number[2];
uint8_t s_screen_temp[2];
//uint8_t s_screen_read_bak[200];
static uint8_t s_screen_read_buffer[BUFFER_SIZE_MAX];
static uint8_t s_phone_read_buffer[BUFFER_SIZE_MAX];

static bool    s_spim_write = false;                   //¼SPIǷ÷ͣǵĻҪRXFIFO
static bool    s_screen_int_flag = false;              //¼ǷյĻıж
static bool    s_phone_reset_flag = false;             //¼ǷյֻĿλź
static bool    s_screen_int_transfer_status = false;   //¼ǷѾʼͨ
bool    s_screen_init_complate = false;                //ĻTPʼɱ־
static uint8_t s_screen_const_transfer_count = 0xff;   //¼ǰͨŵһ,ʼֵ screen_reg_start_data_size

#ifdef USE_FOR_SUMSUNG_S20
uint16_t u16TouchID;
#endif

static void app_tp_transfer_phone(size_t recieve_num);
//static void app_tp_reset_callback(void *data);
#if PHONE_SLAVE_TRANSFER_I2C                           //warning
    static void app_tp_i2cs_callback(e_i2c_s_int_status int_status, size_t recieve_num);
#endif
#if PHONE_SLAVE_TRANSFER_SPI                           //warning
    static void app_tp_spis_callback(hal_spis_event_e event, hal_spi_packet_info_t *packet_info);
#endif

#ifdef USE_FOR_SAMSUNG_Note10Lite
uint8_t MI10_PRO_screen_init_data1[3] = {0xA0,0x00,0x01};
uint8_t MI10_PRO_screen_init_data2[6] = {0xA2,0x03,0x00,0x00,0x00,0x03};
uint8_t MI10_PRO_screen_init_data3[3] = {0xA2,0x02,0x00};
uint8_t MI10_PRO_screen_init_data4[3] = {0xC0,0x07,0x01};

uint8_t MI10_PRO_screen_init_data5[3] = {0xA4,0x06,0x70};
uint8_t MI10_PRO_screen_init_data6[3] = {0xA6,0x00,0x00};
uint8_t MI10_PRO_screen_init_data7[5] = {0xFA,0x20,0x00,0x00,0x78};

uint8_t MI10_PRO_screen_init_data8[6] = {0xA2,0x03,0x20,0x00,0x00,0x00};
uint8_t MI10_PRO_screen_init_data9[2] = {0xA0,0x01};
uint8_t MI10_PRO_screen_init_data10[3] = {0xA0,0x00,0x00};
#endif

#if 1//def ADD_TP_TUNING
//uint8_t MI10_PRO_TP_Tuning_data1[3] = {0xA4,0x00,0x00};		  // System Reset
uint8_t MI10_PRO_TP_Tuning_data2[3] = {0xA4,0x00,0x03}; 		  // FPnl Init
uint8_t MI10_PRO_TP_Tuning_data3[3] = {0xA4,0x00,0x02}; 		  // Pnl Init
uint8_t MI10_PRO_TP_Tuning_data4[4] = {0xA4,0x03,0x13,0x00};  // TuneM
uint8_t MI10_PRO_TP_Tuning_data5[4] = {0xA4,0x03,0x0C,0x00};	 // TuneS
uint8_t MI10_PRO_TP_Tuning_data6[3] = {0xA4,0x05,0x01}; 		 // SvCfg
uint8_t MI10_PRO_TP_Tuning_data7[3] = {0xA4,0x05,0x02}; 		 // SvCx
uint8_t MI10_PRO_TP_Tuning_data8[3] = {0xA4,0x05,0x04}; 		 // SvPnl
#endif

/**************************************************************************
* @name : app_tp_screen_int_callback
* @brief : screen ж ص
* @param[in] :
* @return :
* @retval :
**************************************************************************/
static void app_tp_screen_int_callback(void *data)
{
    s_screen_int_flag = true;
}

/**************************************************************************
* @name : app_tp_screen_int_lvl_low
* @brief : ȡ screen ж IO ƽ
* @param[in] :
* @return : trueIO Ϊ͵ƽ
* @retval :
**************************************************************************/
static bool app_tp_screen_int_lvl_low(void)
{
	uint8_t i = 1;
	uint8_t j = 1;	
#if SCREEN_MASTER_TRANSFER_I2C
//	  i=hal_gpio_get_input_data(g_screen_input_int_pad);
//	  j=hal_gpio_get_input_data(g_screen_input_int_pad);
//    if((i+j)==0)
//		{
//		  return true;
//		}
//else 
//	{
//      return false;
//  }		
    return !hal_gpio_get_input_data(g_screen_input_int_pad);
#elif SCREEN_MASTER_TRANSFER_SPI
    return !hal_gpio_get_input_data(g_screen_input_int_pad); //ӦSPIͨŹżͻȻCS ͨ쳣
#else
    return false;
#endif
}

/**************************************************************************
* @name : app_tp_screen_int_init
* @brief : screen ж IO ʼ
* @param[in] :
* @return :
* @retval :
**************************************************************************/
static void app_tp_screen_int_init(void)
{
    hal_gpio_set_pull_state(g_screen_input_int_pad, ENABLE, DISABLE);         // 1.
    hal_gpio_ctrl_eint(g_screen_input_int_pad, DISABLE);                      // 2.رж
    hal_gpio_init_eint(g_screen_input_int_pad, DETECT_FALLING_EDGE);          // 3.жϳʼ,TPһ㶼½شж
    hal_gpio_reg_eint_cb(g_screen_input_int_pad, app_tp_screen_int_callback); // 4.עص
    hal_gpio_ctrl_eint(g_screen_input_int_pad, ENABLE);                       // 5.ʹж
}

#if 0
/**************************************************************************
* @name : app_tp_phone_reset_init
* @brief : phone reset ж IO ʼ
* @param[in] :
* @return :
* @retval :
**************************************************************************/
static void app_tp_phone_reset_init(void)
{
    /*0.Ϊ*/
    hal_gpio_init_input(g_phone_input_rst_pad);
    /*1.رж*/
    hal_gpio_ctrl_eint(g_phone_input_rst_pad, DISABLE);
    /*2.жϳʼ*/
    hal_gpio_init_eint(g_phone_input_rst_pad, DETECT_RISING_EDGE);
    /*3.עص*/
    hal_gpio_reg_eint_cb(g_phone_input_rst_pad, app_tp_reset_callback);
    /*4.ʹж*/
    hal_gpio_ctrl_eint(g_phone_input_rst_pad, ENABLE);
}
#endif


/**************************************************************************
* @name : app_tp_screen_init
* @brief : screen IO 䣬ʼʼ
* @param[in] :
* @return :
* @retval :
**************************************************************************/
void app_tp_screen_init(void)
{
    hal_gpio_init_output(g_screen_input_rst_pad, IO_LVL_HIGH);
    delayUs(200);
    hal_gpio_set_output_data(g_screen_input_rst_pad, IO_LVL_LOW);
    delayUs(200);
    hal_gpio_set_output_data(g_screen_input_rst_pad, IO_LVL_HIGH);
}

void app_tp_I2C_init(void)
{
    hal_i2c_s_init(CHIP_I2C_ADDRESS, CHIP_I2C_ADDR_BITS);
    hal_i2c_s_set_transfer(app_tp_i2cs_callback);
    hal_i2c_s_nonblocking_read(s_phone_read_buffer, BUFFER_SIZE_MAX); //ý buffer
}




/**************************************************************************
* @name : app_tp_init
* @brief : ʼͨ
* @param[in] :
* @return :
* @retval :
**************************************************************************/
void app_tp_init(void)
{
#ifdef DISABLE_TDDI_I2C_FUNCTION
    hal_gpio_init_output(g_phone_output_int_pad, IO_LVL_HIGH);    //phoneжIO
    hal_gpio_init_output(g_screen_input_rst_pad, IO_LVL_HIGH);	 //ģTP RESET
    
	hal_gpio_set_mode(IO_PAD_TD_SPIM_CLK,IO_MODE_I2C1_SCL);
	hal_gpio_set_mode(IO_PAD_TD_SPIM_CSN,IO_MODE_I2C1_SDA);

	return;
#else	
	hal_gpio_set_pull_state(IO_PAD_TD_SPIM_CLK, ENABLE, DISABLE);
	hal_gpio_set_pull_state(IO_PAD_TD_SPIM_CSN, ENABLE, DISABLE);	
#endif

    app_tp_screen_init();                                        //ʼֻλIO
//app_tp_screen_int_init();                                         //screenж
#ifdef G_PHONE_INT_DEFAULT_LOW
	hal_gpio_init_output(g_phone_output_int_pad, IO_LVL_LOW);	  //phoneжIO
#else
    hal_gpio_init_output(g_phone_output_int_pad, IO_LVL_HIGH);    //phoneжIO
#endif 
    hal_gpio_init_input(g_screen_input_int_pad);
//    hal_gpio_init_output(g_screen_input_rst_pad, IO_LVL_HIGH);	 //ģTP RESET

#if SCREEN_MASTER_TRANSFER_I2C
    hal_i2c_m_dma_init(SCREEN_I2C_ADDRESS, SCREEN_I2C_ADDR_BITS, I2C_MASTER_SPEED);
#elif SCREEN_MASTER_TRANSFER_SPI
    hal_spi_m_dma_init(SPI_MASTER_SPEED, SCREEN_SPI_CPHA, SCREEN_SPI_CPOL);
#endif

#if PHONE_SLAVE_TRANSFER_I2C
//    hal_i2c_s_init(CHIP_I2C_ADDRESS, CHIP_I2C_ADDR_BITS);
//    hal_i2c_s_set_transfer(app_tp_i2cs_callback);
//    hal_i2c_s_nonblocking_read(s_phone_read_buffer, BUFFER_SIZE_MAX); //ý buffer
#elif PHONE_SLAVE_TRANSFER_SPI
    hal_spi_slave_init(PHONE_SPI_CPHA, PHONE_SPI_CPOL, true);                                   // ʼspiԼdma
    hal_spi_slave_register_callback(app_tp_spis_callback);            // עص
    hal_spi_slave_auto_transfer_abort();                              // ֹͣ
    hal_spi_slave_flush_fifo();                                       // Flush FIFO

    /* ÿpacketԶ, circle       mode Ϊfalse, յbuffer     max sizeݺbufferٸ, packetɺûص    */
    hal_spi_slave_set_auto_rx_buffer(s_phone_read_buffer, BUFFER_SIZE_MAX, false); // auto   rx buffer
    hal_spi_slave_set_auto_tx_buffer(phone_reg_const_data[0].write_back, phone_reg_const_data[0].write_back_size, false);   // TX BUFFER

    hal_spi_slave_enable();                                           // spis
    hal_spi_slave_auto_transfer_start();                              // rxԶ
#endif
}


/**************************************************************************
* @name : app_tp_m_transfer_complate
* @brief : ȡͨ״̬
* @param[in] :
* @return :true: ͨ
* @retval :
**************************************************************************/
bool app_tp_m_transfer_complate(void)
{
#if SCREEN_MASTER_TRANSFER_I2C
    return hal_i2c_m_transfer_complate();
#elif SCREEN_MASTER_TRANSFER_SPI
    return hal_spi_m_get_transfer_complate();
#else
    return true;
#endif
}

/**************************************************************************
* @name : app_tp_s_transfer_complate
* @brief : ȡӻͨ״̬
* @param[in] :
* @return :true: ͨ
* @retval :
**************************************************************************/
bool app_tp_s_transfer_complate(void)
{
#if SCREEN_MASTER_TRANSFER_I2C
    return hal_i2c_s_write_complate() && hal_i2c_s_read_complate();
#elif SCREEN_MASTER_TRANSFER_SPI
    return !hal_spi_slave_busy();
#else
    return true;
#endif
}

/**************************************************************************
* @name : app_tp_m_write
* @brief : ͨŷʽ÷txbufferе
* @param[in] :txbuffer:  buffer ͷַ
* @param[in] :buffer_size:  buffer 
* @return :
* @retval :
**************************************************************************/
void app_tp_m_write(const uint8_t *txbuffer, size_t buffer_size)
{
#if SCREEN_MASTER_TRANSFER_I2C
    hal_i2c_m_dma_write(txbuffer, buffer_size);
#elif SCREEN_MASTER_TRANSFER_SPI
    hal_spi_m_dma_write(txbuffer, buffer_size);
    s_spim_write = true;
#endif
}

/**************************************************************************
* @name : app_tp_m_read
* @brief : ͨŷʽ÷txbufferеݺrxbuffer
* @param[in] :cmd:  buffer ͷַ
* @param[in] :cmd_size:  buffer 
* @param[in] :data_buffer: ȡ buffer ͷַ
* @param[in] :data_size: ȡ buffer 
* @return :
* @retval :
**************************************************************************/
void app_tp_m_read(const uint8_t *cmd, size_t cmd_size, uint8_t *data_buffer, size_t data_size)
{
#if SCREEN_MASTER_TRANSFER_I2C
    uint8_t i = 0;
    uint32_t address = 0;

    for (i = 0; i < cmd_size; i++)                          //ȽҪ͵ϵ address
    {
        address |= (uint32_t)cmd[i] << i * 8;
    }
    hal_i2c_m_dma_read(address, cmd_size, data_buffer, data_size);
#elif SCREEN_MASTER_TRANSFER_SPI
    hal_spi_m_dma_read(cmd, cmd_size, data_buffer, data_size);
#endif
}

/**************************************************************************
* @name : app_tp_s_write
* @brief : ͨŷʽ÷txbufferе
* @param[in] :txbuffer:  buffer ͷַ
* @param[in] :buffer_size:  buffer 
* @return :
* @retval :
**************************************************************************/
void app_tp_s_write(const uint8_t *txbuffer, size_t buffer_size)
{
#if PHONE_SLAVE_TRANSFER_I2C
    hal_i2c_s_dma_write(txbuffer, buffer_size);
#elif PHONE_SLAVE_TRANSFER_SPI
    //while (hal_spi_slave_busy());
    hal_spi_slave_auto_transfer_abort();
    hal_spi_slave_flush_fifo();
    hal_spi_slave_set_auto_tx_buffer(txbuffer, buffer_size, true);
    hal_spi_slave_auto_transfer_start();
#endif
}

/**************************************************************************
* @name : app_tp_s_read
* @brief : ͨŷʽrxbuffer
* @param[in] :rxBuffer: ȡ buffer ͷַ
* @param[in] :data_size: ȡ buffer 
* @return :
* @retval :
**************************************************************************/
void app_tp_s_read(void *rxBuffer, size_t data_size)
{
#if PHONE_SLAVE_TRANSFER_I2C
    hal_i2c_s_nonblocking_read(rxBuffer, data_size);
#endif
}

/**************************************************************************
* @name : app_tp_spis_callback
* @brief : SPI slave жϴ
* @param[in] :
* @return :
* @retval :
**************************************************************************/
#if PHONE_SLAVE_TRANSFER_I2C                //warning
//ԡint_status=0Ϊ=2ΪSTOP=1δԵ
//recieve_numΪյָ
static void app_tp_i2cs_callback(e_i2c_s_int_status int_status, size_t recieve_num)
{
#if 0 // 1: test
	if (int_status >2)
	{
		s_phone_read_buffer[2]=int_status;
		s_phone_read_buffer[3]=recieve_num;
		app_tp_m_write(s_phone_read_buffer, 4);
	}
#endif
	
	app_tp_transfer_phone(recieve_num);
	if((s_phone_read_buffer[0]==0x02)&&(s_phone_read_buffer[1]==0x11)&&(int_status==I2C_S_INT_STOP)&&(send_point==0)&&(fingerprint_enable==1))
	{
		hal_gpio_set_output_data(g_phone_output_int_pad, IO_LVL_LOW);
		phone_reg_coord_back[0] = 0x8C;
		phone_reg_coord_back[1] = 0xF1; 
		phone_reg_coord_back[2] = 0x02;
		phone_reg_coord_back[3] = 0x4E;
		phone_reg_coord_back[4] = 0x02;
		phone_reg_coord_back[5] = 0x21;
		phone_reg_coord_back[6] = 0x85;	
		phone_reg_coord_back[7] = 0x30;
		phone_reg_coord_back[8] = 0x00;
		phone_reg_coord_back[9] = 0x00;
		phone_reg_coord_back[10] = 0x00;
		phone_reg_coord_back[11] = 0xFE;
		phone_reg_coord_back[12] = 0x22;
		fingerprint_enable=0;
	}		  
//	else if (int_status==I2C_S_INT_STOP)
//	{
//		TAU_LOGD("s_phone_read_buffer[0]=0x%x, s_phone_read_buffer[1]=0x%x send_point=%d, fingerprint_enable=%d",  s_phone_read_buffer[0], s_phone_read_buffer[1], send_point, fingerprint_enable);
//	}
}
#endif

/**************************************************************************
* @name : app_tp_spis_callback
* @brief : SPI slave жϴ
* @param[in] :
* @return :
* @retval :
**************************************************************************/
#if PHONE_SLAVE_TRANSFER_SPI                //warning
static void app_tp_spis_callback(hal_spis_event_e event, hal_spi_packet_info_t *packet_info)
{
    app_tp_transfer_phone(packet_info->packet_size);
}
#endif

#if 0
/**************************************************************************
* @name : app_tp_reset_callback
* @brief : ֻ IO临λжϴ
* @param[in] :
* @return :
* @retval :
**************************************************************************/
static void app_tp_reset_callback(void *data)
{
    TAU_LOGD("app_tp_reset_callback\n");
    s_phone_reset_flag = true;
    app_tp_s_write(phone_reg_const_data[0].write_back, phone_reg_const_data[0].write_back_size);
#if PHONE_SLAVE_TRANSFER_SPI
    hal_gpio_set_output_data(IO_PAD_AP_INT, IO_LVL_LOW);
#endif
}
#endif


void S20_Start_init(void)
{
	uint8_t len=0;
	uint8_t temp=0;
	uint8_t temp_start_flag=0;	
	//    if(phone_start_flag==1)
	{
		app_tp_m_read(screen_reg_int_data[0].buffer, 1, s_screen_read_buffer, 8);
		while(!hal_i2c_m_transfer_complate());		
		delayMs(2);			
		while(!hal_gpio_get_input_data(g_screen_input_int_pad))
		{
			app_tp_m_read(screen_reg_int_data[0].buffer, 1, s_screen_read_buffer, 8);
			while(!hal_i2c_m_transfer_complate());		
			delayMs(2);
		}
		temp=s_screen_read_buffer[0]&0xf0;
		if((temp==0x10)||(temp==0x20)||(temp==0x30))
		{
			temp_start_flag=1;
		}
		if(temp_start_flag==0)
		{
			app_tp_m_write(MI10_PRO_screen_init_data1, sizeof(MI10_PRO_screen_init_data1));//0xA0,0x00,0x01
			while(!hal_i2c_m_transfer_complate());
			delayMs(1);
			app_tp_m_write(MI10_PRO_screen_init_data2, sizeof(MI10_PRO_screen_init_data2));//0xA2,0x03,0x00,0x00,0x00,0x03
			while(!hal_i2c_m_transfer_complate());
			delayMs(1);		
			app_tp_m_write(MI10_PRO_screen_init_data3, sizeof(MI10_PRO_screen_init_data3));//0xA2,0x02,0x00
			while(!hal_i2c_m_transfer_complate());
			delayMs(1);	
			app_tp_m_write(MI10_PRO_screen_init_data4, sizeof(MI10_PRO_screen_init_data4));//0xC0,0x07,0x01
			while(!hal_i2c_m_transfer_complate());
			delayMs(1);		
			app_tp_m_read(screen_reg_int_data[0].buffer, 1, s_screen_read_buffer, 8);
			while(!hal_i2c_m_transfer_complate());
			if(s_screen_read_buffer[7]>0)
			{
				len=s_screen_read_buffer[7]*8;
				app_tp_m_read(screen_reg_int_data[0].buffer, 1, s_screen_read_buffer, len);
				while(!hal_i2c_m_transfer_complate());		
			}
		}
#endif
		if(hal_gpio_get_input_data(g_screen_input_int_pad))
		{
			s_screen_init_complate = true;
			app_tp_screen_int_init();
			phone_start_flag=0;
		}
	}
}



/**************************************************************************
* @name : app_tp_transfer_screen_const
* @brief : flowдscreen  screen ʼ
* @param[in] :
* @return :
* @retval :
*޸TP1ģʼ
*ִscreen_reg_start_data[]
**************************************************************************/
static void app_tp_transfer_screen_const(void)
{
//    static bool    screen_const_transfer_buffer_ready = true;            // buffer Ƿ׼
	uint8_t ii;
//	uint8_t len=0;
    /**** 1. жϵǰ״̬ͨѽ, ״̬ͨѽҿʼ̻δ****/
#if 0 // test
	uint8_t test_master_read_buffer[10] = {0x08, 0x11, 0x12, 0x13, 0x14, 0x15, 0x16, 0x17, 0x18, 0x19};
	uint8_t write_buffer[10] = {0x04, 0x11, 0x12, 0x13, 0x14, 0x15, 0x16, 0x17, 0x18, 0x19};

//	for (ii =0x20; ii<0x7F; ii++)
	{
		//hal_i2c_m_dma_init(ii, SCREEN_I2C_ADDR_BITS);
		//delayMs(100);
		if (hal_i2c_m_dma_write(write_buffer, 1))
		{
			//break;
		}
		while(!hal_i2c_m_transfer_complate());
		hal_i2c_m_dma_read(test_master_read_buffer, 1, test_master_read_buffer, 2);
	}
#endif


    if (app_tp_m_transfer_complate() && (s_screen_const_transfer_count < screen_reg_start_data_size))
    {
        if (s_spim_write)                                                //SPI дݺҪѽFIFOݶȻӰһζȡ
        {
            hal_spi_m_clear_rxfifo();
            s_spim_write = false;
        }

	#if 1
		
//		#ifndef USE_FOR_SUMSUNG_S20
//		for (ii =0; ii<screen_reg_start_data_size; ii++)
//		{
//            if (!screen_reg_start_data[ii].read_flag)     //ǰͨŲҪأֱд
//            {
//                app_tp_m_write(screen_reg_start_data[ii].buffer, screen_reg_start_data[ii].txbuffer_size);
//            }
//            else                                             //ǰͨҪأдٶ
//            {
//                app_tp_m_read(screen_reg_start_data[ii].buffer, screen_reg_start_data[ii].txbuffer_size, \
//                              s_screen_read_bak, screen_reg_start_data[ii].rxbuffer_size);
//            }
//			while(!hal_i2c_m_transfer_complate());
//		}
//		#endif
		#ifdef USE_FOR_SAMSUNG_Note10Lite
		
	#if 1	
	
		if(phone_start_flag==1)
		{
			S20_Start_init();
		}
	#endif					
	
	#if 0//
		delayMs(100);
		app_tp_m_read(screen_reg_int_data[0].buffer, screen_reg_int_data[0].txbuffer_size, s_screen_number, screen_reg_int_data[0].rxbuffer_size);
		while(!hal_i2c_m_transfer_complate());
	#endif
	#ifdef USE_FOR_SUMSUNG_S20
		s_screen_init_complate = true;
	#endif
		
	#else
        /**** 2. ͻȡӻ ****/
        if (screen_const_transfer_buffer_ready)
        {
            screen_const_transfer_buffer_ready = false;
            if (!screen_reg_start_data[s_screen_const_transfer_count].read_flag)     //ǰͨŲҪأֱд
            {
                app_tp_m_write(screen_reg_start_data[s_screen_const_transfer_count].buffer, screen_reg_start_data[s_screen_const_transfer_count].txbuffer_size);
            }
            else                                                             //ǰͨҪأдٶ
            {
                app_tp_m_read(screen_reg_start_data[s_screen_const_transfer_count].buffer, screen_reg_start_data[s_screen_const_transfer_count].txbuffer_size, \
                              s_screen_number, screen_reg_start_data[s_screen_const_transfer_count].rxbuffer_size);
            }
			s_screen_init_complate = true;
        }
        /**** 3. ͨݣ׼һͨŵbuffer ****/
        else
        {
            screen_const_transfer_buffer_ready = true;
            s_screen_const_transfer_count = app_tp_screen_analysis_const(s_screen_const_transfer_count, s_screen_number, \
                                            screen_reg_start_data[s_screen_const_transfer_count].rxbuffer_size);

            if (s_screen_const_transfer_count >= screen_reg_start_data_size)
            {
                s_screen_init_complate = true;
            }
        }
	#endif	
    }
}

/**************************************************************************
* @name : ap_tp_calibration
* @brief : ����У׼����
* @param[in] :
* @return :
* @retval :
**************************************************************************/

void ap_tp_calibration(void)
{
	// app_tp_m_write(MI10_PRO_TP_Tuning_data1, sizeof(MI10_PRO_TP_Tuning_data1));    // System Reset  
	// while(!hal_i2c_m_transfer_complate());
	// delayMs(10);
	app_tp_m_write(MI10_PRO_TP_Tuning_data2, sizeof(MI10_PRO_TP_Tuning_data2));     // FPnl Init
	while(!hal_i2c_m_transfer_complate());
	delayMs(1);
	app_tp_m_write(MI10_PRO_TP_Tuning_data3, sizeof(MI10_PRO_TP_Tuning_data3));     // Pnl Init
	while(!hal_i2c_m_transfer_complate());
	delayMs(1);
	app_tp_m_write(MI10_PRO_TP_Tuning_data4, sizeof(MI10_PRO_TP_Tuning_data4));    // TuneM
	while(!hal_i2c_m_transfer_complate());
	delayMs(1);
	app_tp_m_write(MI10_PRO_TP_Tuning_data5, sizeof(MI10_PRO_TP_Tuning_data5));    // TuneS
	while(!hal_i2c_m_transfer_complate());
	delayMs(1);
	app_tp_m_write(MI10_PRO_TP_Tuning_data6, sizeof(MI10_PRO_TP_Tuning_data6));    // SvCfg
	while(!hal_i2c_m_transfer_complate());
	delayMs(1);
	app_tp_m_write(MI10_PRO_TP_Tuning_data7, sizeof(MI10_PRO_TP_Tuning_data7));    // SvCx
	while(!hal_i2c_m_transfer_complate());
	delayMs(1);
	app_tp_m_write(MI10_PRO_TP_Tuning_data8, sizeof(MI10_PRO_TP_Tuning_data8));    // SvPnl
	while(!hal_i2c_m_transfer_complate());
	delayMs(1);
}


/**************************************************************************
* @name : app_tp_transfer_screen_start
* @brief : flowдscreenʼʼ
* @param[in] :
* @return :
* @retval :
**************************************************************************/
void app_tp_transfer_screen_start(void)
{
//	s_screen_init_complate = false;
	s_screen_const_transfer_count = 0;
//	app_tp_screen_init();
#ifndef DISABLE_I2C_INIT_CODE    
    app_tp_transfer_screen_const();
#endif
	s_screen_int_flag = false;
}

/**************************************************************************
* @name : app_tp_transfer_screen_int
* @brief : screenжϺ󣬰flowдscreenЭת
* @param[in] :
* @return :
* @retval :
*޸TP2ȡģ鱨㣡
*ִscreen_reg_int_data[]ҲԼд
**************************************************************************/
void app_tp_transfer_screen_int(void)
{
	uint8_t len=0,number=0;
	uint8_t temp_len=0;
	
	bool screen_gpio_int = false;
	static uint8_t screen_int_transfer_count = 0;            //¼ǰͨŵһ
	static bool    screen_int_transfer_buffer_ready = true;  // buffer Ƿ׼
	//    static uint8_t test_flag = 0;
	//	  s_screen_init_complate=false;//Ϊ¼⽫ƬΪ·ݣFT8719̩ĹͨѶ
	if (!s_screen_init_complate)                             //TP ʼδɣȽгʼ
	{
		app_tp_transfer_screen_const();
		return;
	}


    /**** 1. ж screen Ƿ񷢳жź ****/
    // s_screen_int_flag:           жźű־λ
    // app_tp_screen_int_lvl_low :  SPI ʱͨʱżcsߵͨ쳣ñ־λڽ
    screen_gpio_int = (s_screen_int_flag || app_tp_screen_int_lvl_low());
    if (screen_gpio_int)
    {
		s_screen_int_flag = false;

		app_tp_m_read(screen_reg_int_data[0].buffer, 1, s_screen_read_buffer, 8);
		while(!hal_i2c_m_transfer_complate());
		if(s_screen_read_buffer[7]>0)
		{
			len=s_screen_read_buffer[7]*8;
			app_tp_m_read(screen_reg_int_data[0].buffer, 1, &s_screen_read_buffer[8], len);
			while(!hal_i2c_m_transfer_complate());
			temp_len=len+7;
		}
		if(s_screen_read_buffer[temp_len]>0)
		{
			len=s_screen_read_buffer[7]*8;
			app_tp_m_read(screen_reg_int_data[0].buffer, 1, &s_screen_read_buffer[temp_len+1], len);
			while(!hal_i2c_m_transfer_complate());		
		}			
		delayUs(100);
		
		while(!hal_gpio_get_input_data(g_screen_input_int_pad))
		{
			app_tp_m_read(screen_reg_int_data[0].buffer, 1, s_screen_read_buffer, 8);
			while(!hal_i2c_m_transfer_complate());		
			delayUs(100);
			if(s_screen_read_buffer[7]>0)
			{
				len=s_screen_read_buffer[7]*8;
				app_tp_m_read(screen_reg_int_data[0].buffer, 1, &s_screen_read_buffer[8], len);
				while(!hal_i2c_m_transfer_complate());
				delayUs(100);			
			}		
		}	
		
		screen_int_transfer_buffer_ready = true;
		screen_int_transfer_count = app_tp_screen_analysis_int(screen_int_transfer_count, s_screen_read_buffer,screen_reg_int_data[2].rxbuffer_size);
		screen_int_transfer_count = 0;
		s_screen_int_transfer_status = false;
    }
}



/**************************************************************************
* @name : app_tp_transfer_phone
* @brief : ݽӦĴ
* @param[in] : recieve_numݳ
* @return :
* @retval :
**************************************************************************/
static void app_tp_transfer_phone(size_t recieve_num)
{
    const uint8_t *phone_write_buffer;
    size_t phone_write_buffer_size = 0;
    /* ݽжǷҪԼ𸴵bufferָ */
    if (recieve_num > 0)
    {
    #if 0// 1: test
		s_phone_read_buffer[3]=recieve_num;
		app_tp_m_write(s_phone_read_buffer, 4);
	#endif
        app_tp_phone_analysis_data(s_phone_read_buffer, recieve_num, &phone_write_buffer, &phone_write_buffer_size);
    }

    app_tp_s_read(s_phone_read_buffer, BUFFER_SIZE_MAX);
    if (phone_write_buffer_size)                                      //0ʾҪֻ÷buffer
    {
        app_tp_s_write(phone_write_buffer, phone_write_buffer_size);
    }
}

/**************************************************************************
* @name : app_tp_phone_reset_on
* @brief : ȡֻλźŵ״̬
* @param[in] :
* @return :
* @retval :
**************************************************************************/
bool app_tp_phone_reset_on(void)
{
    return s_phone_reset_flag;
}

/**************************************************************************
* @name : app_tp_phone_clear_reset_on
* @brief : ֻλźŵ״̬
* @param[in] :
* @return :
* @retval :
**************************************************************************/
void app_tp_phone_clear_reset_on(void)
{
    s_phone_reset_flag = false;
}

#else

void app_tp_screen_init(void)
{

}

void app_tp_init(void)
{

}

void app_tp_transfer_screen_int(void)
{

}

void app_tp_transfer_screen_start(void)
{

}

bool app_tp_phone_reset_on(void)
{
    return false;
}

void app_tp_phone_clear_reset_on(void)
{

}

void app_tp_s_write(const uint8_t *txbuffer, size_t buffer_size)
{

}

bool app_tp_enter_sleep_on(void)
{
    return false;
}

#endif

