/*******************************************************************************
*
*
* File:        tau_operations.h
* Description  λֽڲضͷļ
* Version      V0.1
* Date         2020-09-07
* Author       lzy
 *******************************************************************************/
#ifndef __TAU_BYTEOPS_H
#define __TAU_BYTEOPS_H

/**
 * \name ͨλ
 * @{
 */

/** \brief λ */
#ifndef TAU_BITS_PER_LONG
    #define TAU_BITS_PER_LONG       32
#endif

/** \brief ֽλ */
#define TAU_BITS_PER_BYTE       8

/** @} */


/******************************************************************************/

/**
 * \name ͨλ
 * @{
 */

/** \brief bitλ
 * TAU_BIT(2) is 0x4
 */
#define TAU_BIT(bit)                  (1u << (bit))

/** \brief ֵλ
 * TAU_SBF(0xFF, 8) is 0xff00
 */
#define TAU_SBF(value, field)         ((value) << (field))

/** \brief bitλ
 * TAU_BIT_SET(0, 8) is 0x100
 */
#define TAU_BIT_SET(data, bit)        ((data) |= TAU_BIT(bit))

/** \brief bit
 * TAU_BIT_CLR(0xFF, 2) is 0xfb
 */
#define TAU_BIT_CLR(data, bit)        ((data) &= ~TAU_BIT(bit))

/** \brief bitλ,  mask ָλ
 * TAU_BIT_SET_MASK(0xF0F0, 0xF00) is 0xfff0
 */
#define TAU_BIT_SET_MASK(data, mask)  ((data) |= (mask))

/** \brief bit,  mask ָλ
 * TAU_BIT_CLR_MASK(0xFFFF, 0xFF00) is 0xff
 */
#define TAU_BIT_CLR_MASK(data, mask)  ((data) &= ~(mask))

/** \brief bitת
 * TAU_BIT_TOGGLE(0xFFFF, 0) is 0xfffe
 * TAU_BIT_TOGGLE(0x0000, 1) is 0x2
 */
#define TAU_BIT_TOGGLE(data, bit)     ((data) ^= TAU_BIT(bit))

/** \brief bit޸
 * TAU_BIT_MODIFY(0, 8, 1) is 0x100
 * TAU_BIT_MODIFY(0xFFFF, 1, 0) is 0xfffd
 */
#define TAU_BIT_MODIFY(data, bit, value) \
    ((value) ? TAU_BIT_SET(data, bit) : TAU_BIT_CLR(data, bit))

/** \brief bitǷλ
 * TAU_BIT_ISSET(0xF0F1, 1) is 0
 * TAU_BIT_ISSET(0xF0F2, 1) is 2
 */
#define TAU_BIT_ISSET(data, bit)      ((data) & TAU_BIT(bit))

/** \brief ȡbitֵ
 * TAU_BIT_GET(0xF0F1, 1) is 0
 * TAU_BIT_GET(0xF0F2, 1) is 1
 */
#define TAU_BIT_GET(data, bit)        (TAU_BIT_ISSET(data, bit) ? 1 : 0)

/** \brief bitֵ
 * TAU_BIT_CHECK(0xF5FF, 4) is 1
 */
#define TAU_BIT_CHECK(data, bit)  \
    (((data) & TAU_BIT(bit)) ? 1 : 0)

/** \brief ȡ n bits ֵ
 * TAU_BITS_MASK(2) is 0x3
 */
#define TAU_BITS_MASK(n)              (~((~0u) << (n)))

/** \brief ȡλֵ
 * TAU_BITS_GET(0xF5FF, 0x0F00, 8) is 0x5
 */
#define TAU_BITS_GET(data, mask, pos)  \
    (((data) & (mask)) >> (pos))

/** \brief ȡλֵ
 * TAU_BITS_CHECK(0xF5FF, 0x0F00) is 1
 */
#define TAU_BITS_CHECK(data, mask)  \
    (((data) & (mask)) ? 1 : 0)

/** \brief ޸λֵ
 * TAU_BITS_MODIFY(0xF5FF, 0x0FF0, 0x8A0) is 0xF8AF
*/
#define TAU_BITS_MODIFY(data, clear_mask, set_mask) \
    (data) = (((data) & (~(clear_mask))) | (set_mask))

/** \brief λֵ
 * TAU_WRITE_REG32(0x05FF, 0xFFFA) is 0xFFFA
*/
#define TAU_WRITE_REG32(data, value) ((data) = (value))

/** \brief λֵ
 * TAU_READ_REG32(0x05FF) is 0x05FF
*/
#define TAU_READ_REG32(data) (data)


/** @} */

/******************************************************************************/

/**
 * \brief ȡ2-byteĸλbyte
 *
 * \par ʾ
 * \code
 *  uint16_t a = 0x1234;
 *  uint16_t b;
 *
 *  b = TAU_MSB(a);  //b=0x12
 * \endcode
 */
#define TAU_MSB(x)       (((x) >> 8) & 0xff)

/**
 * \brief ȡ2-byteĵλbyte
 *
 * \par ʾ
 * \code
 *  uint16_t a = 0x1234;
 *  uint16_t b;
 *
 *  b = TAU_LSB(a);  //b=0x34
 * \endcode
 */
#define TAU_LSB(x)       ((x) & 0xff)

/**
 * \brief ȡ2-wordĸλword
 *
 * \par ʾ
 * \code
 *  uint32_t a = 0x12345678;
 *  uint32_t b;
 *
 *  b = TAU_MSW(a);  //b=0x1234
 * \endcode
 */
#define TAU_MSW(x)       (((x) >> 16) & 0xffff)

/**
 * \brief ȡ2-wordĵλword
 *
 * \par ʾ
 * \code
 *  uint32_t a = 0x12345678;
 *  uint32_t b;
 *
 *  b = TAU_LSW(a);  //b=0x5678
 * \endcode
 */
#define TAU_LSW(x)       ((x) & 0xffff)

/**
 * \brief 32-bitĸλword͵λword
 *
 * \par ʾ
 * \code
 *  uint32_t a = 0x12345678;
 *  uint32_t b;
 *
 *  b = TAU_WORDSWAP(a); //b=0x56781234
 * \endcode
 */
#define TAU_WORDSWAP(x)  (TAU_MSW(x) | (TAU_LSW(x) << 16))

/**
 * \brief 32-bitֽ˳
 *
 * \par ʾ
 * \code
 *  uint32_t a = 0x12345678;
 *  uint32_t b;
 *
 *  b = TAU_LONGSWAP(a); //b=0x78563412
 * \endcode
 */
#define TAU_LONGSWAP(x)  ((TAU_LLSB(x) << 24) | \
                          (TAU_LNLSB(x) << 16) | \
                          (TAU_LNMSB(x) << 8)  | \
                          (TAU_LMSB(x)))

#define TAU_LLSB(x)      ((x) & 0xff)                    /**< \brief ȡ32bit1ֽ */
#define TAU_LNLSB(x)     (((x) >> 8) & 0xff)             /**< \brief ȡ32bit2ֽ */
#define TAU_LNMSB(x)     (((x) >> 16) & 0xff)            /**< \brief ȡ32bit3ֽ */
#define TAU_LMSB(x)      (((x) >> 24) & 0xff)            /**< \brief ȡ32bit4ֽ */
#define TAU_LNSB(x,n)    (((x) >> ((n) * 8) ) & 0xff)      /**< \brief ȡ32bitnֽ , 0 - 3*/

/**
 * @}
 */

#endif /* __TAU_BYTEOPS_H */

/* end of file */

