/*******************************************************************************
*
*
* File:         hal_dsi_tx_ctrl.h
* Description:  hal mipi dsi tx ͷļ
* Version:      V0.1
* Date:         2021-04-23
* Author:       wuc
 *******************************************************************************/
#ifndef __HAL_DSI_TX_CTRL_H__
#define __HAL_DSI_TX_CTRL_H__

/*******************************************************************************
* 1.Included files
*******************************************************************************/
#include "tau_dsi_datatype.h"
#include "tau_device_datatype.h"
#include "tau_common.h"
#include "hal_gpio.h"
#include "stdint.h"
#include "stdbool.h"

/*******************************************************************************
* 2.Global constant and macro definitions using #define
*******************************************************************************/

/*******************************************************************************
* 3.Global structures, unions and enumerations using typedef
*******************************************************************************/

/**
* @brief  ƻMIPI TXṹ
*/
typedef struct
{
    bool                          used;                      /* handleʹñ־λ */
    uint8_t                       lane_num;
    dsi_virtual_channel_e         channel_id;
    dsi_video_mode_type_e         vid_mode;
    dsi_tx_cmd_tx_type_e          cmd_tx_type;               /* ʼģʽʽ0:HS; 1:LP */
    uint8_t                       pclk_offset;               /* lane byte clkHFPLONG HTP */
    uint32_t                      dpi_vsa;
    uint32_t                      dpi_vbp;
    uint32_t                      dpi_vfp;
    uint32_t                      dpi_hsa;
    uint32_t                      dpi_hbp;
    uint32_t                      dpi_hfp;
    dsi_base_trans_info_t         base_info;                 /* mipi video תϢ */
    uint32_t                      tx_line_delay;             /* tx ʾӳ,˾,ڷֱлʱȷлʱ */
    float                         tx_frame_rate;             /* Ĭ60Hz,Ϊ,Ϊdebugʹ */
    bool                          tx_clkawayshs;             /* ĬΪfalse, Ϊtrueʱvideo modeڼclkLP */
    uint8_t                       blank_rows;                /* ĬΪ0, ʹã0ʱЧʾ²blank_rows */
    uint8_t                       blank_columns;             /* ĬΪ0, ʹã0ʱЧʾҲblank_columns */
    bool                          lp_exit_lpdt;              /* ÿһLP CMD˳LPDT */
    bool                          tx_cmd_mode_sync;          /* TX command mode ͬ */
} hal_dsi_tx_ctrl_handle_t;

/**
* @brief  crop parameters
*/
typedef struct
{
    uint16_t    crop_top;
    uint16_t    crop_bottom;
    uint16_t    crop_left;
    uint16_t    crop_right;
} hal_dsi_tx_crop_t;

/**
* @brief  MIPI TXʼ
* @param  tx_ctrl_handle: MIPI TXʵ
* @retval ɹ:0 ʧ:-1
*/
bool hal_dsi_tx_ctrl_init(hal_dsi_tx_ctrl_handle_t *tx_ctrl_handle);

/**
* @brief  MIPI TXʼ
* @param  tx_ctrl_handle: MIPI TXʵ
* @retval ɹ:0 ʧ:-1
*/
bool hal_dsi_tx_ctrl_deinit(hal_dsi_tx_ctrl_handle_t *tx_ctrl_handle);

/**
* @brief  MIPI TXʵ
* @param  
* @retval tx_ctrl_handle: MIPI TXʵ
*/
hal_dsi_tx_ctrl_handle_t *hal_dsi_tx_ctrl_create_handle(void);

/**
* @brief  MIPI TXͷʵ
* @param  tx_ctrl_handle: MIPI TXʵ
* @retval ɹ:0 ʧ:-1
*/
bool hal_dsi_tx_ctrl_release_handle(hal_dsi_tx_ctrl_handle_t *tx_ctrl_handle);

/**
* @brief  MIPI TXʼ
* @param  tx_ctrl_handle: MIPI TXʵ
* @retval ɹ:0 ʧ:-1
*/
bool hal_dsi_tx_ctrl_start(hal_dsi_tx_ctrl_handle_t *tx_ctrl_handle);

/**
* @brief  MIPI TXֹͣ
* @param  tx_ctrl_handle: MIPI TXʵ
* @retval ɹ:0 ʧ:-1
*/
bool hal_dsi_tx_ctrl_stop(hal_dsi_tx_ctrl_handle_t *tx_ctrl_handle);

/**
* @brief  ʼpanel
* @param  
* @retval 
*/
void hal_dsi_tx_ctrl_enter_init_panel_mode(void);

/**
* @brief  ˳ʼpanel
* @param  
* @retval 
*/
void hal_dsi_tx_ctrl_exit_init_panel_mode(void);

/**
* @brief  MIPI TX
* @param  data_type: ͣοödsi_data_type_e
* @param  vc: ͨţοödsi_virtual_channel_e
* @param  cmd: DCSָ
* @param  size: ȡݳ
* @param  data: ݴŵַ
* @retval 
*/
void hal_dsi_tx_ctrl_read_cmd(uint8_t data_type, uint8_t vc, uint8_t cmd, uint8_t size, uint8_t *data);

/**
* @brief  MIPI TX
* @param  data_type: ͣοödsi_data_type_e
* @param  vc: ͨţοödsi_virtual_channel_e
* @param  cmd_count: ɱ
* @param  ...: ɱ
* @retval 
*/
void hal_dsi_tx_ctrl_write_cmd(uint8_t data_type, uint8_t vc, uint8_t cmd_count, ...);

/**
* @brief  MIPI TX
* @param  data_type: ͣοödsi_data_type_e
* @param  vc: ͨţοödsi_virtual_channel_e
* @param  size: data
* @param  data: data
* @retval 
*/
void hal_dsi_tx_ctrl_write_array_cmd(uint8_t data_type, uint8_t vc, uint8_t size, const uint8_t *data);

/**
* @brief  TXʱӷƵϵͳ
* @param  esc_div: TXʱӷƵϵ
* @retval 
*/
void hal_dsi_tx_ctrl_set_escape_clock_div(uint8_t esc_div);

/**
* @brief  ˸λŲ
* @param  state: Resetߡ
* @retval 
*/
void hal_dsi_tx_ctrl_panel_reset_pin(gpio_level_e state);

/**
* @brief  òʾ
* @param  st_line: ʼ
* @param  st_col: ʼ
* @param  end_line: 
* @param  end_col: 
* @retval 
*/
void hal_dsi_tx_ctrl_set_partial_disp_area(uint32_t st_line, uint32_t st_col, uint32_t end_line, uint32_t end_col);

/**
* @brief  ʾܿ
* @param  pd_en: زʾ
* @retval 
*/
void hal_dsi_tx_ctrl_set_partial_disp(function_state_e pd_en);

/**
* @brief  øдɫ
* @param  R: RGBR
* @param  G: RGBG
* @param  B: RGBB
* @retval 
*/
void hal_dsi_tx_ctrl_set_overwrite_rgb(uint8_t R, uint8_t G, uint8_t B);

/**
* @brief  ȫд
* @param  ow_en: ȫд
* @retval 
*/
void hal_dsi_tx_ctrl_set_overwrite(function_state_e ow_en);

/**
* @brief  RGBBGR
* @param  endianness: ѡRGBBGRʾ
* @retval 
*/
void hal_dsi_tx_ctrl_set_endianness(dpi_endianness_type_e endianness);

/**
* @brief  CCM
* @param  coef: ƻοṹccm_coef_t
* @retval 
*/
void hal_dsi_tx_ctrl_set_ccm(ccm_coef_t coef);

/**
* @brief  TX VPG
* @param  vpg_en: ʹVPG
* @param  style: VPGʽ
* @retval 
*/
void hal_dsi_tx_ctrl_set_vpg(function_state_e vpg_en, dsi_tx_vpg_style_e style);

/**
* @brief  video modeʹLP CMD
* @param  lp_en:ʹLP CMD
* @retval 
*/
void hal_dsi_tx_ctrl_set_lp_cmd(function_state_e lp_en);

/**
* @brief  ütxͼ
* @param  tx_ctrl_handle: dsi tx handle
* @param  crop: ü
* @retval 
*/
void hal_dsi_tx_crop_pic(hal_dsi_tx_ctrl_handle_t *tx_ctrl_handle, hal_dsi_tx_crop_t *crop);

#if !defined(ISP_568) && !defined(ISP_368)
    /* ISP_518/ISP_308 ӿ */
    /**
    * @brief  ˮƽת
    * @param  flip_en: ˮƽת
    * @retval 
    */
    void hal_dsi_tx_ctrl_set_horizon_flip(function_state_e flip_en);

    /**
    * @brief  tx filter
    * @param  tx_ctrl_handle: dsi tx handle
    * @param  filter_h: ˮƽfilter
    * @param  filter_v: ֱfilter
    * @retval true/false
    */
    bool hal_dsi_tx_ctrl_set_cus_pq_filter(hal_dsi_tx_ctrl_handle_t *tx_ctrl_handle, uint32_t filter_h[32][2], uint32_t filter_v[32][2]);

    /**
    * @brief  txԵ,ֻ
    * @param  tx_ctrl_handle: dsi tx handle
    * @param  threshold: Եǿǿ
    * @param  slope: ԵǿΧ
    * @retval true/false
    */
    bool hal_dsi_tx_ctrl_set_cus_pq_edge(hal_dsi_tx_ctrl_handle_t *tx_ctrl_handle, uint8_t threshold, uint16_t slope);
#else
    /* ISP_568/ISP_368 ӿ */
    /**
    * @brief  tx filter
    * @param  tx_ctrl_handle: dsi tx handle
    * @param  filter: tx filter
    * @retval true/false
    */
    bool hal_dsi_tx_ctrl_set_cus_pq_filter(hal_dsi_tx_ctrl_handle_t *tx_ctrl_handle, uint32_t filter[32]);

    /**
    * @brief  TX command mode ͬӿ,յTEźźãֹ˺
    * @param  tx_ctrl_handle: dsi tx handle
    * @retval true/false
    */
    bool hal_dsi_tx_ctrl_cmd_mode_rcv_te(hal_dsi_tx_ctrl_handle_t *tx_ctrl_handle);
#endif

#endif //__HAL_DSI_TX_CTRL_H__
