/*******************************************************************************
*
*
* File:        hal_i2c_master.h
* Description  i2c hal file
* Version      V0.1
* Date         2021-10-14
* Author       zhanghz
*******************************************************************************/

#ifndef __HAL_I2C_MASTER_H__
#define __HAL_I2C_MASTER_H__

#include "tau_device_datatype.h"
#include "tau_common.h"
#include "string.h"

/**************************************************************************
* @name : hal_i2c_m_dma_init
* @brief : i2c master dma ʼ
* @param[in] : slave_addrĿӻַ
* @param[in] : addr_bitsĿӻַλ
* @param[in] : i2c_speed_hz: ͨ
* @return :
* @retval :
**************************************************************************/
void hal_i2c_m_dma_init(uint8_t slave_addr, uint8_t addr_bits, uint32_t i2c_speed_hz);

/**************************************************************************
* @name : hal_i2c_m_dma_write
* @brief : i2c master dma 
* @param[in] : txBufferbuffer
* @param[in] : data_sizeݸ
* @return : STATUS_SUCCESS DMA ͨһȫ
* @return : ͳҪµú
* @retval :
**************************************************************************/
status_t hal_i2c_m_dma_write(const uint8_t *txBuffer, size_t data_size);

/**************************************************************************
* @name : hal_i2c_m_dma_read
* @brief : i2c master dma 
* @param[in] : reg_addressȷͼĴַӻ
* @param[in] : reg_sizeַֽ
* @param[in] : rxBufferbuffer
* @param[in] : data_sizeݳ
* @return : STATUS_SUCCESSĴַͳɹDMAͨһɽ
* @return : ճҪµú
* @retval :
**************************************************************************/
status_t hal_i2c_m_dma_read(uint32_t reg_address, size_t reg_size, uint8_t *rxBuffer, size_t data_size);

/**************************************************************************
* @name : hal_i2c_m_transfer_complate
* @brief : ȡ i2c master ״̬
* @param[in] :
* @return : trueݷ
* @return : falseݻڷ
* @retval :
**************************************************************************/
bool hal_i2c_m_transfer_complate(void);

/**************************************************************************
* @name : hal_i2c_m_set_high_impedance
* @brief :  I2C IOΪ̬
* @param[in] :
* @return :
* @retval :
**************************************************************************/
void hal_i2c_m_set_high_impedance(void);
/**************************************************************************
* @name : hal_i2c_m_deinit
* @brief : i2c IPȥʼصʹܡʱӣ
* @param[in] :
* @return :
* @retval :
***************************************************************************/
void hal_i2c_m_deinit(void);
#endif /* __HAL_I2C_MASTER_H__*/

