/*******************************************************************************
*
*
* File:          hal_pwm.h
* Description pwm HALͷļ
* Version      V0.1
* Date         2021-03-17
* Author       wuc
 *******************************************************************************/
#ifndef __HAL_PWM_H__
#define __HAL_PWM_H__

/*******************************************************************************
* 1.Included files
*******************************************************************************/
#include "tau_device_datatype.h"
#include "tau_common.h"
#include "hal_gpio.h"

/*******************************************************************************
* 2.Global constant and macro definitions using #define
*******************************************************************************/

/*******************************************************************************
* 3.Global structures, unions and enumerations using typedef
*******************************************************************************/
/*! @brief PWMܵĶ */
typedef enum _pwm_out_ctrl_e
{
    PWMO_CTRL_KEEP       = 0,
    PWMO_CTRL_LOW        = 1,
    PWMO_CTRL_HIGH       = 2,
    PWMO_CTRL_TOGGLE     = 3,
    PWMO_CTRL_MAX
} pwm_out_ctrl_e;

/*******************************************************************************
* 4.Global variable extern declarations
*******************************************************************************/

/*******************************************************************************
* 5.Global function prototypes
*******************************************************************************/
/**
* @brief  PWMOʼ
* @param  
* @retval 
*/
void hal_pwm_out_init(void);

/**
* @brief  PWMOʼ
* @param  
* @retval 
*/
void hal_pwm_out_deinit(void);

/**
* @brief  PWMOָͣ
* @param  stateؿ
* @retval 
*/
void hal_pwm_out_pause(function_state_e state);

/**
* @brief  PWMO岢ʼ
* @param  ctl0ֵthr0ʱĲοöpwm_out_ctrl_e
* @param  ctl1ֵthr1ʱĲοöpwm_out_ctrl_e
* @param  thr0ֵ0λus
* @param  thr1ֵ1λus
* @param  periodһڵʱ䣬λus
* @retval 
*/
void hal_pwm_out_config_all(pwm_out_ctrl_e ctl0, pwm_out_ctrl_e ctl1, uint32_t thr0, uint32_t thr1, uint32_t period);

/**
* @brief  ͬģʽPWMOв
* @param  ctl0ֵthr0ʱĲοöpwm_out_ctrl_e
* @param  ctl1ֵthr1ʱĲοöpwm_out_ctrl_e
* @param  thr0ֵ0λus
* @param  thr1ֵ1λus
* @param  periodһڵʱ䣬λus
* @retval 
*/
void hal_pwm_out_sync_all(pwm_out_ctrl_e ctl0, pwm_out_ctrl_e ctl1, uint32_t thr0, uint32_t thr1, uint32_t period);

/**
* @brief  pwmԿƱ
* @param  polarity: ԣfalse:ȸߺͣtrue:ȵͺ
* @param  duty_ratio: ռձ(0-total_ratio)
* @param  total_ratio: ϸ
* @param  frequency: ƵʣλHZ
* @retval 
*/
void hal_pwm_out_config_duty_ratio(bool polarity, uint16_t duty_ratio, uint16_t total_ratio, uint32_t frequency);

/**
* @brief  ͬģʽPWMO
* @param  periodһڵʱ䣬λus
* @retval 
*/
void hal_pwm_out_sync_period(uint32_t period);

/**
* @brief  ͬģʽPWMOĿ
* @param  ctl0ֵthr0ʱĲοöpwm_out_ctrl_e
* @param  ctl1ֵthr1ʱĲοöpwm_out_ctrl_e
* @retval 
*/
void hal_pwm_out_sync_ctl(pwm_out_ctrl_e ctl0, pwm_out_ctrl_e ctl1);

/**
* @brief  ֵͬģʽPWMOֵ
* @param  thr0ֵ0λus
* @param  thr1ֵ1λus
* @retval 
*/
void hal_pwm_out_sync_thr(uint32_t thr0, uint32_t thr1);

/**
* @brief  ͬͣģʽָͣPWMO
* @param  pause_stateָͣ
* @retval 
*/
void hal_pwm_out_sync_pause(function_state_e pause_state);

/**
* @brief  PWMIʼ
* @param  
* @retval 
*/
void hal_pwm_in_init(void);

/**
* @brief  PWMIʼ
* @param  
* @retval 
*/
void hal_pwm_in_deinit(void);

/**
* @brief  עPWMIжϻصشPWMIжָ룬οpwm_int_type_e
* @param  cb_funcصַ
* @retval 
*/
void hal_pwm_in_register_callback(fcb_type cb_func);

/**
* @brief  PWMIжϵĿ
* @param  high_overflow_enhigh overflowжʹܿ
* @param  low_overflow_enlow overflowжʹܿ
* @param  total_overflow_entotal overflowжʹܿ
* @param  high_done_enhigh doneжʹܿ
* @param  low_done_enlow doneжʹܿ
* @param  total_done_entotal doneжʹܿ
* @retval 
*/
void hal_pwm_in_config_int(function_state_e high_overflow_en, function_state_e low_overflow_en, function_state_e total_overflow_en,
                           function_state_e high_done_en, function_state_e low_done_en, function_state_e total_done_en);

/**
* @brief  PWMIжϵĿ
* @param  pwm_intжͣοöpwm_int_type_e
* @param  enableƿ
* @retval 
*/
void hal_pwm_in_set_int(pwm_int_type_e pwm_int, function_state_e enable);

/**
* @brief  رPWMIж
* @param  
* @retval 
*/
void hal_pwm_in_clear_int(void);

/**
* @brief  PWMIж
* @param  stateؿ
* @retval 
*/
void hal_pwm_in_ctrl_int(function_state_e state);

/**
* @brief  ȡPWMIʱ
* @param  
* @retval ʱλus
*/
uint32_t hal_pwm_in_get_total_period(void);

/**
* @brief  ȡPWMIߵƽʱ
* @param  
* @retval ߵƽʱλus
*/
uint32_t hal_pwm_in_get_high_period(void);

/**
* @brief  ȡPWMI͵ƽʱ
* @param  
* @retval ͵ƽʱλus
*/
uint32_t hal_pwm_in_get_low_period(void);

/**
* @brief  ȡPWMIۻ
* @param  
* @retval ģʹܵǰʱظ32λ¼
*/
uint32_t hal_pwm_in_get_current_count(void);

#if defined(ISP_568) || defined(ISP_368)
    /**
    * @brief  ѡPWMOIO
    * @param  pad: PWMOIO,ĬΪIO_PAD_AP_SWIRE,ѡͨIO_PAD_TD_SPIM_MISOIO_PAD_TD_LEDPWM
    * @retval 
    */
    void hal_pwm_out_sel_io(io_pad_e pad);
#endif
#endif /* __HAL_PWM_H__ */
