/*******************************************************************************
*
*
* File:        hal_spi_touch.h
* Description  spi hal file
* Version      V0.1
* Date         2021-10-25
* Author       zhanghz
*******************************************************************************/

#ifndef __HAL_SPI_MASTER_H__
#define __HAL_SPI_MASTER_H__

#include "tau_device_datatype.h"
#include "tau_common.h"
#include "string.h"

/**************************************************************************
* @name : hal_spi_m_dma_init
* @brief : SPIM DMA ʼ
* @param[in] :speedͨ
* @param[in] :cpha: õһʱػߵڶʱЧ
* @param[in] :cpol: ߿ʱʱӵƽ
* @return :
* @retval :
**************************************************************************/
void hal_spi_m_dma_init(uint32_t speed, uint8_t cpha, uint8_t cpol);

/**************************************************************************
* @name : hal_spi_m_dma_write
* @brief : SPIM 
* @param[in] :data_buffer:  buffer ͷַ
* @param[in] :data_size:  buffer 
* @return :STATUS_SUCCESS: óɹݲһ
* @return :òɹҪ÷
* @retval :
**************************************************************************/
status_t hal_spi_m_dma_write(const uint8_t *data_buffer, size_t data_size);

/**************************************************************************
* @name : hal_spi_m_dma_read
* @brief : SPIM ȡ
* @param[in] :cmd:  buffer ͷַ
* @param[in] :cmd_size:  buffer 
* @param[in] :data_buffer: ȡ buffer ͷַ
* @param[in] :data_size:   ȡ buffer 
* @return :STATUS_SUCCESS: óɹݲһȡ
* @return :òɹҪ÷
* @retval :
**************************************************************************/
status_t hal_spi_m_dma_read(const uint8_t *cmd, size_t cmd_size, uint8_t *data_buffer, size_t data_size);

/**************************************************************************
* @name : hal_spi_m_get_transfer_complate
* @brief : ȡ SPIM ͨ״̬
* @param[in] :
* @return :trueͨ
* @retval :
**************************************************************************/
bool hal_spi_m_get_transfer_complate(void);

/**************************************************************************
* @name : hal_spi_m_clear_rxfifo
* @brief :  rxfifo е
* @param[in] :
* @return :
* @retval :
**************************************************************************/
void hal_spi_m_clear_rxfifo(void);

/**************************************************************************
* @name : hal_spi_m_set_high_impedance
* @brief :  SPI IOΪ̬
* @param[in] :
* @return :
* @retval :
**************************************************************************/
void hal_spi_m_set_high_impedance(void);
/**************************************************************************
* @name : hal_spi_m_deinit
* @brief :  SPI ȥʼ(صSPIM)
* @param[in] :
* @return :true
* @retval :
**************************************************************************/
bool hal_spi_m_deinit(void);

#endif

