/*******************************************************************************
*
*
* File:        hal_system.h
* Description  hal ͨϵͳӿͷļ
* Version      V0.1
* Date         2021-05-21
* Author       lzy
 *******************************************************************************/
#ifndef __HAL_SYSTEM_H__
#define __HAL_SYSTEM_H__
/*******************************************************************************
* 1.Included files
*******************************************************************************/
#include "tau_common.h"

/*******************************************************************************
* 2.Global constant and macro definitions using #define
*******************************************************************************/

/*******************************************************************************
* 3.Global structures, unions and enumerations using typedef
*******************************************************************************/

/*******************************************************************************
* 4.Global variable extern declarations
*******************************************************************************/

/*******************************************************************************
* 5.Global function prototypes
*******************************************************************************/

/**
* @brief  system ʼ
* @param  none
* @retval none
*/
void hal_system_init(uint32_t sysclk);

/**
* @brief  system ʼ console
* @param  baud_rate 
* @retval none
*/
void hal_system_init_console(uint32_t baud_rate);

/**
* @brief  mcuidleģʽ,ȴжϻ
* @param  disable_systick: idleʱǷرsystick(˳idle ָsystick)
* @retval none
*/
void hal_system_idle_mode(bool disable_systick);

/**
* @brief  עsystickص
* @param  cb_funcصַ
* @retval 
*/
void hal_system_register_systick_cb(fcb_type cb_func);

/**
* @brief  sys tickt
* @param  ms: sys tickt , Χ1-10ms
* @retval true/false
*/
bool hal_system_enable_systick(uint8_t ms);

/**
* @brief  ȡsystickt
* @param  none
* @retval ǰsysticktֵ
*/
bool hal_system_disable_systick(void);

/**
* @brief  ȡsystickt
* @param  none
* @retval ǰsysticktֵ
*/
uint32_t hal_system_get_tick(void);

/**
* @brief  deep sleep mode ģʽ, ȴAP_RSTN 
* @param  polarity true:ػ, false:½ػ
* @retval none
*/
void hal_system_deep_sleep_mode(bool polarity);

/**
* @brief  ùflash(ʹùעر,Ļ)
* @param  enable:true:ͨF_SPIڲflash , false:ͨF_SPIڲflash
* @retval true/false
*/
bool hal_system_share_flash_mode(bool enable);

/**
* @brief  sleep mode 
* @param  enable
* @retval none
*/
void hal_system_sleep_mode(bool enable);

/**
* @brief  reset chip
* @param  none
* @retval none
*/
void hal_system_reset_chip(void);

/**
* @brief  PVD
* @param  none
* @retval none
*/
void hal_system_set_pvd(bool enable);

/**
* @brief  VCCԴأ
*         ʹó: VCC磬13D13MʹԴʱرڲVCC,ֹԴ
* @param  enable: true:CP, false:رCP
* @retval none
*/
void hal_system_set_vcc(bool enable);

/**
* @brief  ûֽʽflashȡ,ҳȡÿҳ1024ֽ
* @param  *usr_cfg_t_addr(׵ַ),
          usr_cfg_t_size(СԳ1024԰ҳҲҳ)
          flash_page ҳ0~63
* @retval bool  
*/
bool hal_system_flash_read(uint8_t *usr_cfg_t_addr,  uint16_t usr_cfg_t_size, uint8_t flash_page);

/**
* @brief  ûֽʽflash(ޣƵд),ҳд룬ÿҳ1024ֽ
* @param  *usr_cfg_t_addr(׵ַ),
          usr_cfg_t_size(СԳ1024԰ҳдҲҳд)
          Ƽҳ˳д뷽ʽһα0ҳʼд룬ſ1~63ҳд
          flash_page дҳ0~63
* @retval bool  УsizeǷ񳬳
*/
bool hal_system_flash_write(uint8_t *usr_cfg_t_addr,  uint16_t usr_cfg_t_size, uint8_t flash_page);

/**
* @brief  flash˳deep sleep power mode
* @param  0xABָ
* @retval null
*/
void hal_system_flash_release_power_down(void);

/**
* @brief  flashdeep sleep power mode
* @param  0xB9ָ
* @retval null
*/
void hal_system_flash_power_down(void);

#if defined(ISP_568) || defined(ISP_368)
    /**
    * @brief  DPHYڲУ׼
    * @param  en: ʹܿ
    * @retval none
    */
    void hal_system_set_phy_calibration(bool en);
#endif

/**
* @brief  ȡλõdebug state
* @param  none
* @retval debug state
*/
uint32_t hal_system_get_debug_state(void);

/**
* @brief  clear debug state(debug only)
* @param  none
* @retval none
*/
void hal_system_clear_debug_state(void);

#endif //__HAL_SYSTEM_H__
